void moveDensity(short x, short y, short z)
{
	float	distance, direction, spread_rate = 64,
			new_vector_x, new_vector_y, new_vector_z;

	int		current_voxel, new_voxel, i, samples, density_per_sample = 8,
			new_x, new_y, new_z;

	current_voxel = (x +(globalVolume->sizeX*y) +(globalVolume->sizeX*globalVolume->sizeY*z));
	samples = (int)globalVolume->data[current_voxel].density / density_per_sample;

	if(globalVolume->data[current_voxel].vector_x != 0
	|| globalVolume->data[current_voxel].vector_y != 0
	|| globalVolume->data[current_voxel].vector_z != 0)
	{
		new_x = x + globalVolume->data[current_voxel].vector_x;
		new_y = y + globalVolume->data[current_voxel].vector_y;
		new_z = z + globalVolume->data[current_voxel].vector_z;

		if(new_x > 0 && new_x < globalVolume->sizeX
		&& new_y > 0 && new_y < globalVolume->sizeY
		&& new_z > 0 && new_z < globalVolume->sizeZ)
		{
			new_voxel = (new_x + (new_y * globalVolume->sizeX) + (new_z * globalVolume->sizeX * globalVolume->sizeY));

			globalVolume->data[new_voxel].density_buffer = globalVolume->data[current_voxel].density;

			globalVolume->data[current_voxel].vector_x = 0;
			globalVolume->data[current_voxel].vector_y = 0;
			globalVolume->data[current_voxel].vector_z = 0;
		}
	}
	else
	for(i=0; i<samples; i++)
	{
		distance = rand()/(RAND_MAX+1.0);

		direction = (2.0*rand() / (RAND_MAX+1.0)) - 1;

		new_vector_x = (float)globalVolume->data[current_voxel].density * distance * direction / spread_rate;

		direction = (2.0*rand() / (RAND_MAX+1.0)) - 1;

		new_vector_y = (float)globalVolume->data[current_voxel].density * distance * direction / spread_rate;

		direction = (2.0*rand() / (RAND_MAX+1.0)) - 1;

		new_vector_z = (float)globalVolume->data[current_voxel].density * distance * direction / spread_rate;

		new_x = x + (int)new_vector_x;
		new_y = y + (int)new_vector_y;
		new_z = z + (int)new_vector_z;

		if(new_x > 0 && new_x < globalVolume->sizeX
		&& new_y > 0 && new_y < globalVolume->sizeY
		&& new_z > 0 && new_z < globalVolume->sizeZ)
		{
			new_voxel = (new_x +(globalVolume->sizeX*new_y) +(globalVolume->sizeX*globalVolume->sizeY*new_z));

			if(new_voxel!=current_voxel)
			{
				if (globalVolume->data[new_voxel].vector_x_buffer +  (int)new_vector_x < 127
				&&	globalVolume->data[new_voxel].vector_x_buffer +  (int)new_vector_x > -127)
					globalVolume->data[new_voxel].vector_x_buffer += (int)new_vector_x;

				if (globalVolume->data[new_voxel].vector_y_buffer +  (int)new_vector_y < 127
				&&	globalVolume->data[new_voxel].vector_y_buffer +  (int)new_vector_y > -127)
					globalVolume->data[new_voxel].vector_y_buffer += (int)new_vector_y;

				if (globalVolume->data[new_voxel].vector_z_buffer +  (int)new_vector_z < 127
				&&	globalVolume->data[new_voxel].vector_z_buffer +  (int)new_vector_z > -127)
					globalVolume->data[new_voxel].vector_z_buffer += (int)new_vector_z;

				if (globalVolume->data[new_voxel].density_buffer +  (int)density_per_sample < 255)
					globalVolume->data[new_voxel].density_buffer += (int)density_per_sample;
				else
					globalVolume->data[current_voxel].density_buffer += (int)density_per_sample;
			}
		}
	}
}