#define VOXEL_SIZE 16

typedef struct _voxel{
unsigned char	red;
unsigned char	green;
unsigned char	blue;
unsigned char	alpha;
unsigned char	material;
unsigned char	padding;
unsigned char	heat;
unsigned char	heat_buffer;
unsigned char	density;
unsigned char	density_buffer;
		 char	vector_x;
		 char	vector_y;
		 char	vector_z;
		 char	vector_x_buffer;
		 char	vector_y_buffer;
		 char	vector_z_buffer;
}voxel;

typedef struct _volume{
short			sizeX, sizeY, sizeZ;
int				num_voxels;
unsigned char	stride;
voxel			*data;
}volume;

volume *globalVolume;

//This function loads a .vxl file into memory
volume *loadVolume(char*, unsigned char);

//This function creates a new .vxl file of a specified size
int newVolume(short, short, short, char*);

//This function saves a colour to a specified voxel in a .vxl file
int setVoxelColour(short, short, short, unsigned char, unsigned char, unsigned char, unsigned char, char*);

//This function saves a material to a specified voxel in a .vxl file
int setVoxelMaterial(short, short, short, unsigned char, char*);
